note
   description: "Root class of the application"
   date: "2011 April 22"
   version: "1.0"
   author: "Michel Train & Gunnar Gotshalks"

class MAIN

create make

--------------------------------------------------------------------------------
feature {NONE} -- Initialization

make
    -- Builds context of test and run it
  local
  forward : COLLECTION_ITERATOR[EMPLOYEE]
  backward : REVERSE_ITERATOR[EMPLOYEE]
  do
    build_employees_list(5)           -- Make a list of employees
    create forward.make(employees)    -- Create a (forward) iterator on this list
    create backward.make(employees)   -- Create a backward iterator on this list

    print("From first to last%N")
    print("------------------%N")
    print_employees(forward)

    print("%N%NFrom last to first%N")
    print("------------------%N")
    print_employees(backward)
  end

--------------------------------------------------------------------------------
feature {NONE} -- Private

employees : LINKED_LIST[EMPLOYEE]

build_employees_list (nb : INTEGER)
    -- Build a list with 'nb' members
  local
    i : INTEGER
    emp : EMPLOYEE
  do
    create employees.make
    from i := 1 until i > nb
    loop
      create emp.make_from_number(i)
      employees.extend(emp)
      i := i + 1
    end
  end

--------------------------------------------------------------------------------
feature -- Demonstration

print_employees (iter : ITERATOR2[EMPLOYEE])
   -- Demonstrate the use of iterators
  do
    from iter.start until iter.is_done
    loop
      iter.item.print_it
      iter.next
   end
end

end
