note
   description: "A reverse generic ITERATOR for an indexed COLLECTION"
   date: "2011 April 22"
   version: "1.0"
   author: "Michel Train & Gunnar Gotshalks"

class REVERSE_ITERATOR[E]
  inherit COLLECTION_ITERATOR[E]
            redefine exhausted, is_done, start, first, next end
create make

--------------------------------------------------------------------------------
feature -- Queries

exhausted, is_done : BOOLEAN
    -- Whether all elements have been visited
  do
    target_collection.start
    Result := index < target_collection.index
  end

--------------------------------------------------------------------------------
feature -- Commands

start, first
    -- Go to the aggregate first position: start the iteration
  do
    target_collection.finish
    index := target_collection.index
  end

next
    -- Advance to the next element
  do
    index := index - 1
  end

end

